#include <sys\types.h>
#include <sys\stat.h>
#include <math.h>
#include <float.h>
#include <graph.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <malloc.h>
#include <graph.h>

#define DUAL256RES 100
#define HRES256COLOR 200
#define UP   (-1)
#define DOWN 1

/* 320x400 and 360x400 Masm functions */

extern void s360x480(void);
extern void s320x400(void);
extern void writep16(int,int,int);
extern void xorp16(int,int,int);

extern void writep15(int,int,int);
extern int readp16(int,int);
extern int readp15(int,int);
extern void line16(int,int,int,int,int);
extern void line15(int,int,int,int,int);
extern void dischar16(int,int,int,int,int);
extern void dischar15(int,int,int,int,int);


/* local prototypes */

void setvideomode(int);
void setpixel(int,int);
int getpixel(int,int);
void setcolor(int);
void moveto(int,int);
int lineto(int,int);
int rectangle(int,int,int,int,int);
long imagesize(int,int,int,int);
void getimage(int,int,int,int, unsigned char far *);
void source_image(int,int,int,int, unsigned char far *);
void putimage(int,int,unsigned char far *,int);
void outtext(char *);
void settextposition(int,int);
void rectfill(int,int,int,int);
void getvideoconfig(struct videoconfig *);
void source_obj(void);


int vidqnow;
int vidqqqcol;
int texqqx,texqqy,fqqqcol,bqqqcol;
int bordervalue;
int fillvalue;
int yqqqmax;
int xqqqmax;
struct xycoord vqqqb;
struct videoconfig xqqqvid;

extern char i_file[20];
extern int i_unit;

extern int o_unit;                      /* object number */
extern char o_name[13];                 /* object name */
extern unsigned int o_length;           /* object length */
extern unsigned char o_data[10000][3];  /* object data */
extern char o_file[20];                 /* object file name */


void setvideomode(mode)      /* extends video mode to 256 color non-standard */
int mode;
{
  vidqnow = mode;

  if (mode == DUAL256RES)
   {
    _setvideomode(19);
    s320x400();
   }
  else
   {
    if (mode == HRES256COLOR)
     {
      _setvideomode(19);
      s360x480();
     }
    else
     {
      _setvideomode(mode);
     }
   }
}

void getvideoconfig(vidn)
struct videoconfig *vidn;
{

  if (vidqnow == DUAL256RES)
   {
    (*vidn).numxpixels = 320;
    (*vidn).numypixels = 400;
    (*vidn).numcolors = 256;
    (*vidn).bitsperpixel = 8;
    (*vidn).numvideopages = 2;
    (*vidn).numtextcols = 40;
    (*vidn).numtextrows = 50;
    (*vidn).adapter = _VGA;
   }
  else
   {
    if (vidqnow == HRES256COLOR)
     {
      (*vidn).numxpixels = 360;
      (*vidn).numypixels = 480;
      (*vidn).numcolors = 256;
      (*vidn).bitsperpixel = 8;
      (*vidn).numvideopages = 1;
      (*vidn).numtextcols = 44;
      (*vidn).numtextrows = 58;
      (*vidn).adapter = _VGA;
     }
    else
     {
      _getvideoconfig(vidn);
     }
   }
}

void setpixel(x,y)
int x,y;
{

  if (vidqnow == DUAL256RES)
   {
    writep15(x,y,vidqqqcol);
   }
  else
   {
    if (vidqnow == HRES256COLOR)
     {
      writep16(x,y,vidqqqcol);
     }
    else
     {
      _setpixel(x,y);
     }
   }
}

int getpixel(x,y)
int x,y;
{
  int ap;

  if (vidqnow == DUAL256RES)
   {
    ap = readp15(x,y);
   }
  else
   {
    if (vidqnow == HRES256COLOR)
     {
      ap = readp16(x,y);
     }
    else
     {
      ap = _getpixel(x,y);
     }
   }
   return(ap);
}

void setcolor(color)
int color;
{
  vidqqqcol = color;
  _setcolor(color);
}

void moveto(x,y)
int x,y;
{

  if (vidqnow == DUAL256RES)
   {
    vqqqb.xcoord = x;
    vqqqb.ycoord = y;
   }
  else
   {
    if (vidqnow == HRES256COLOR)
     {
      vqqqb.xcoord = x;
      vqqqb.ycoord = y;
     }
    else
     {
      _moveto(x,y);
     }
   }
}

int lineto(x,y)
int x,y;
{
  int wd;

  if (vidqnow == DUAL256RES)
   {
    line15(vqqqb.xcoord,vqqqb.ycoord,x,y,vidqqqcol);
    vqqqb.xcoord = x;
    vqqqb.ycoord = y;
    wd = 1;
   }
  else
   {
    if (vidqnow == HRES256COLOR)
     {
      line16(vqqqb.xcoord,vqqqb.ycoord,x,y,vidqqqcol);
      vqqqb.xcoord = x;
      vqqqb.ycoord = y;
      wd = 1;
     }
    else
     {
      wd = _lineto(x,y);
     }
   }
   return wd;
}

int rectangle(cont,x1,y1,x2,y2)
int cont,x1,y1,x2,y2;
{
   int rv,tx,ty;

  if (vidqnow == DUAL256RES)
   {
    tx = vqqqb.xcoord;
    ty = vqqqb.ycoord;
    moveto(x1,y1);
    lineto(x2,y1);
    lineto(x2,y2);
    lineto(x1,y2);
    lineto(x1,y1);
    moveto(tx,ty);
    if (cont == _GFILLINTERIOR)
     {
      rectfill(x1,y1,x2,y2);
     }
   vqqqb.xcoord = tx;
   vqqqb.ycoord = ty;
   }
  else
   {
    if (vidqnow == HRES256COLOR)
     {
      tx = vqqqb.xcoord;
      ty = vqqqb.ycoord;
      moveto(x1,y1);
      lineto(x2,y1);
      lineto(x2,y2);
      lineto(x1,y2);
      lineto(x1,y1);
      moveto(tx,ty);
      if (cont == _GFILLINTERIOR)
       {
        rectfill(x1,y1,x2,y2);
       }
      vqqqb.xcoord = tx;
      vqqqb.ycoord = ty;
     }
    else
     {
      rv = _rectangle(cont,x1,y1,x2,y2);
     }
   }
   return rv;
}

long imagesize(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
 int tdx,tdy;
 long imr;

  if (vidqnow == DUAL256RES)
   {
    tdx = abs(x2-x1);
    tdy = abs(y2-y1);
    imr = (long) (tdx+1)*(tdy+1) + 8;
   }
  else
   {
    if (vidqnow == HRES256COLOR)
     {
      tdx = abs(x2-x1);
      tdy = abs(y2-y1);
      imr = (long) (tdx+1)*(tdy+1) + 8;
     }
    else
     {
      imr = _imagesize(x1,y1,x2,y2);
     }
   }
 return(imr);
}

void getimage(x1,y1,x2,y2,image1)
int x1,y1,x2,y2;
unsigned char far *image1;
{
  register int ii,jj;
  unsigned char dpix;
  int sx,sy;
  int jind;

  sx = (x2-x1)+1;
  sy = (y2-y1)+1;
  if (vidqnow == DUAL256RES || vidqnow == HRES256COLOR)
   {
    for (jj = y1;jj <= y2;jj++)
     {
      jind = (jj-y1) * sx;
      for (ii = x1;ii <= x2;ii++)
       {
        dpix = (unsigned char) getpixel(ii,jj);
        image1[jind + (ii-x1) + 4] = dpix;  
       }
      }
    image1[0] = ((unsigned char) (sx % 256));
    image1[1] = ((unsigned char) (sx / 256));

    image1[2] = ((unsigned char) (sy % 256));
    image1[3] = ((unsigned char) (sy / 256));
   }
  else
   {
     _getimage(x1,y1,x2,y2,image1);
   }
}

void source_image(x1,y1,x2,y2,image1)
int x1,y1,x2,y2;
unsigned char far *image1;
{
 int fh;
 unsigned int fv;
 long fp,qp;
 unsigned char simc[200];
 int sx,sy,nl,ii,jj;
 int jind,im;
 char s_file[20];
 char namd[20];

 strcpy(s_file,i_file);
 nl = strlen(s_file);
 itoa(i_unit,&s_file[nl-2],16);
 strcpy(namd,s_file);
 namd[nl-4] = '_';

 fh = open(s_file,O_TEXT|O_CREAT,S_IWRITE|S_IREAD);
 close(fh);

 fh = open(s_file,O_TEXT|O_RDWR);       
 fp = lseek(fh,0l,SEEK_SET);

 sx = (x2-x1)+1;
 sy = (y2-y1)+1;

 sprintf(simc,"/* size of icon */\nint %s_x = %i;\nint %s_y = %i;\n",namd,sx,namd,sy);
 fv = strlen(simc);
 write(fh,simc,fv);
 sprintf(simc,"\nunsigned char %s_icon[%i][%i] = \n{\n ",namd,(sy+1),(sx+1));
 fv = strlen(simc);
 write(fh,simc,fv);
 for (jj = 0;jj <= sy;jj++)
   {
    jind = (jj-y1) * sx;
    for (ii = 0;ii <= sx;ii++)
     {
      if (ii == sx && jj == sy)
       {
        sprintf(simc,"%#2.2x ",(int) image1[jind + (ii-x1) + 4]);
       }
      else
       {
        sprintf(simc,"%#2.2x, ",(int) image1[jind + (ii-x1) + 4]);
       }
      fv = strlen(simc);
      write(fh,simc,fv);
      im = ii % 10;
      if (im == 9)
       {
        sprintf(simc,"\n    ");
        fv = strlen(simc);
        write(fh,simc,fv);
       }
     }
    sprintf(simc,"\n ");
    fv = strlen(simc);
    write(fh,simc,fv);
   }
  sprintf(simc,"\n};");
  fv = strlen(simc);
  write(fh,simc,fv);
  close(fh);
}

void putimage(x,y,image1,action)
int x,y,action;
unsigned char far *image1;
{
  register int ii,jj;
  unsigned char dpix;
  int ocol,mpix;
  int jind;
  int x2,y2,sx,sy;
  int rx1,rx2,ry1,ry2;

  if (vidqnow == DUAL256RES || vidqnow == HRES256COLOR)
   {
    rx2 = (int) image1[0];
    rx1 = (int) image1[1];
    sx = (rx1 * 256) + rx2;

    ry2 = (int) image1[2];
    ry1 = (int) image1[3];
    sy = (ry1 * 256) + ry2;

    x2 = x + sx;
    y2 = y + sy;
    ocol = vidqqqcol;
    for (jj = y;jj <= y2;jj++)
     {
      jind =  (jj-y) * sx;
      for (ii = x;ii <= x2;ii++)
       {
        dpix = image1[jind + (ii-x) + 4];

        switch (action)
         {
          case _GAND:
               dpix = (unsigned char) (getpixel(ii,jj) & dpix);
               setcolor(dpix);
               setpixel(ii,jj);
               break;
          case _GOR:
               dpix = (unsigned char) (getpixel(ii,jj) | dpix);
               setcolor(dpix);
               setpixel(ii,jj);
               break;
          case _GPRESET:
               mpix = (int) dpix;
               mpix = ~mpix;
               dpix = (unsigned char) mpix;
               setcolor(dpix);
               setpixel(ii,jj);
               break;
          case _GPSET:
               setcolor(dpix);
               setpixel(ii,jj);
               break;
          case _GXOR:
               dpix = (unsigned char) (getpixel(ii,jj) ^ dpix);   
               setcolor(dpix);
               setpixel(ii,jj);
               break;
         }
       }
     }
   }
  else
   {
    _putimage(x,y,image1,action);
   }
}

void source_obj()
{
 int fh;
 unsigned int fv;
 long fp,qp;
 unsigned char simc[200];
 int nl,jj;
 int jind,im;
 char s_file[20];
 char namd[20];

 if (o_length == 0)
  {
   return;
  }

 strcpy(s_file,o_file);
 nl = strlen(s_file);
 itoa(o_unit,&s_file[nl-2],16);
 strcpy(namd,s_file);
 namd[nl-4] = '_';
        
 fh = open(s_file,O_TEXT|O_CREAT,S_IWRITE|S_IREAD);
 close(fh);

 fh = open(s_file,O_TEXT|O_RDWR);       
 fp = lseek(fh,0l,SEEK_SET);

 sprintf(simc,"/* size of object */\nint %s_l = %i;\n",namd,o_length);
 fv = strlen(simc);
 write(fh,simc,fv);

 sprintf(simc,"\nunsigned char %s_obj[3][%i] = \n{\n ",namd,o_length+1);
 fv = strlen(simc);
 write(fh,simc,fv);

 for (jj = 0;jj <= o_length;jj++)
   {
    sprintf(simc,"%#2.2x, %#2.2x, %#2.2x,\n",(int) o_data[jj][0],(int) o_data[jj][1],(int) o_data[jj][2]);
    fv = strlen(simc);
    write(fh,simc,fv);
   }
  sprintf(simc,"\n};");
  fv = strlen(simc);
  write(fh,simc,fv);
  close(fh);
}




void outtext(newt)
char *newt;
{
  int sl,ii,cc,dx,dy;
  
  bqqqcol = 0;

  if (vidqnow == DUAL256RES)
   {
    sl = strlen(newt);
    for (ii = 0;ii < sl;ii++)
     {
       cc = newt[ii];
       dx = (texqqx-1) * 8;
       dy = (texqqy-1) * 8;
       dischar15(cc,dx,dy,fqqqcol,bqqqcol);
       texqqx = texqqx + 1;
       if (texqqx >= 39)
        {
         texqqx = 0;
         texqqy++;
        }
     }
   }
  else
   {
    if (vidqnow == HRES256COLOR)
     {
      sl = strlen(newt);
      for (ii = 0;ii < sl;ii++)
       {
         cc = newt[ii];
         dx = (texqqx-1) * 8;
         dy = (texqqy-1) * 8;
         dischar16(cc,dx,dy,fqqqcol,bqqqcol);
         texqqx++;
       }
       if (texqqx >= 44)
        {
         texqqx = 0;
         texqqy++;
        }
     }
    else
     {
      _outtext(newt);
     }
   }
}

void settextposition(y,x)
int x,y;
{
  if ((x < 1) || (y < 1))
   {
    return;
   }
  texqqy = y;
  texqqx = x;
  if (vidqnow != HRES256COLOR && vidqnow != DUAL256RES)
   {
    _settextposition(y,x);
   }
}

int settextcolor(col)
int col;
{
   int kk;

  if (vidqnow == HRES256COLOR || vidqnow == DUAL256RES)
   {
    fqqqcol = col;
    kk = _settextcolor(col);
   }
  else
   {
    kk = _settextcolor(col);
   }
   return(kk);
}

void rectfill(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
   int y,ox,oy;

    ox = vqqqb.xcoord;
    oy = vqqqb.ycoord;

   for (y = y1; y <= y2;y++)
    {
     moveto(x1,y);
     lineto(x2,y);
    }

    vqqqb.xcoord = ox;
    vqqqb.ycoord = oy;
}

